=== debian/changelog ===
pakcs (3.3.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Update versioned B-Ds and Ds for PAKCS components.
    + Bump Standards-Version: to 4.5.1. No changes needed.
  * debian/watch:
    + Update format version to 4.
  * debian/pakcs.install:
    + Update for renamed documentation files.
  * debian/pakcsinitrc:
    + Drop file. Not required anymore.
  * debian/rules:
    + Fix +DEB_DH_INSTALLCHANGELOGS_ARGS with correct (renamed) RELNOTES.md
      file name.
    + Drop some chmod operations for files that are gone in this release.
    * Adapt various file tweask to new upstream release.
    + Move more doc files to /usr/share/doc and symlink.
  * debian/pakcs.manpages:
    + Don't ship runcurry.1 man page. Binary has vanished in this upstream
      release.
  * debian/copyright:
    + Add auto-generated copyright.in template file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 04 Feb 2021 17:43:47 +0100

pakcs (2.2.0-2) unstable; urgency=medium

  * debian/control:
    + Bump Standards-Version: to 4.5.0. No changes needed.
    + Make sure we rebuild against curry-frontend (>= 1.0.4-5~).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 29 Sep 2020 17:42:57 +0200
